package nl.rubend.clonebook;

import jakarta.ws.rs.ApplicationPath;
import nl.rubend.clonebook.rest.*;
import nl.rubend.clonebook.security.AuthenticationResource;
import nl.rubend.clonebook.security.AuthorizationFilter;
import nl.rubend.clonebook.websocket.WebSocket;
import org.glassfish.jersey.server.ResourceConfig;
import org.springframework.context.annotation.Configuration;

@Configuration
@ApplicationPath("/rest")
public class AppConfig extends ResourceConfig {

    public AppConfig() {
        register(ChatService.class);
        register(MediaService.class);
        register(NotificationService.class);
        register(PageService.class);
        register(PostService.class);
        register(RecaptchaKey.class);
        register(UserService.class);
        register(AuthenticationResource.class);
        register(WebSocket.class);
        register(AuthorizationFilter.class);

    }
}