package nl.rubend.clonebook.utils;

import com.sun.mail.smtp.SMTPTransport;
import nl.rubend.clonebook.exceptions.ClonebookException;

import jakarta.mail.Message;
import jakarta.mail.MessagingException;
import jakarta.mail.Session;
import jakarta.mail.internet.InternetAddress;
import jakarta.mail.internet.MimeMessage;
import java.io.IOException;
import java.sql.Date;
import java.util.Objects;
import java.util.Properties;

public class SendEmail {
	public static void sendEmail(String to, String subject,String message) {
		try {
			Properties prop = new Properties();
			prop.load(Objects.requireNonNull(Thread.currentThread().getContextClassLoader().getResourceAsStream("database.properties")));
			Properties props = System.getProperties();
			props.setProperty("mail.transport.protocol", "smtp");
			props.setProperty("mail.smtp.port", "587");
			props.setProperty("mail.smtp.host", prop.getProperty("smtphost"));
			props.setProperty("mail.smtp.auth", "true");
			props.setProperty("mail.smtp.starttls.enable", "true");
			Session session = Session.getInstance(props, null);
			Message msg = new MimeMessage(session);
			msg.setFrom(new InternetAddress("clonebook@rubend.nl"));
			msg.setRecipients(Message.RecipientType.TO, InternetAddress.parse(to, false));
			msg.setSubject(subject);
			msg.setContent(message, "text/html");
			msg.setSentDate(new Date(System.currentTimeMillis()));
			SMTPTransport t = (SMTPTransport) session.getTransport();
			t.connect(prop.getProperty("smtphost"), prop.getProperty("smtpuser"), prop.getProperty("smtppass"));
			t.sendMessage(msg, msg.getAllRecipients());
			t.close();
		} catch (MessagingException | IOException e) {
			e.printStackTrace();
			throw new ClonebookException("failed to send email!");
		}
	}
}
