package nl.rubend.clonebook.utils;

import org.springframework.stereotype.Service;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.sql.*;
import java.io.InputStream;
import java.util.Properties;
import java.util.stream.Collectors;

@Service
public class SqlInterface {
	public SqlInterface() {
		connect();
	}
	private static Connection conn;
	public static void connect() {
		try {
			System.out.println(System.getProperty("java.class.path"));
			Properties prop=new Properties();
			InputStream stream=Thread.currentThread().getContextClassLoader().getResourceAsStream("database.properties");
			if(stream==null) throw new RuntimeException("database.properties not found!");
			prop.load(stream);
			Class.forName(prop.getProperty("driver"));
			conn = DriverManager.getConnection(prop.getProperty("url"), prop.getProperty("user"), prop.getProperty("pass"));
			try {
				conn.createStatement().executeQuery("select 1 from user");
			} catch(SQLException e) {
				System.out.println("Database not initialized, initializing now");
				init();
			}
		} catch (SQLException | IOException | ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	private static void init() {
		try {
			String result = new BufferedReader(new InputStreamReader(Thread.currentThread().getContextClassLoader().getResourceAsStream("initsql.sql")))
					.lines().collect(Collectors.joining("\n"));
			for (String s : result.split("\n")) {
				if (s.startsWith("#")) continue;
				conn.createStatement().executeUpdate(s);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public static PreparedStatement prepareStatement(String statement) throws SQLException {
		try {
			PreparedStatement testStatement = conn.prepareStatement("select 1");
			ResultSet executed = testStatement.executeQuery();
			executed.next();
			executed.getInt("1");
		} catch(NullPointerException | SQLException e) {
			e.printStackTrace();
			System.out.println("CONNETION WAS CLOSED");//Om het te vinden in de TomCat logs.
			connect();
		}
		return conn.prepareStatement(statement);
	}
}
